require File.dirname(__FILE__) + '<%= '/..' * class_nesting_depth %>/../test_helper'

class <%= class_name %>Test < Test::Unit::TestCase
  fixtures :<%= table_name %>

	NEW_<%= class_name.upcase %> = {}	# e.g. {:name => 'Test <%= class_name %>', :description => 'Dummy'}
	REQ_ATTR_NAMES 			 = %w( ) # name of fields that must be present, e.g. %(name description)
	DUPLICATE_ATTR_NAMES = %w( ) # name of fields that cannot be a duplicate, e.g. %(name description)

  def setup
    # Retrieve fixtures via their name
    # @first = <%= table_name %>(:first)
  end

  def test_raw_validation
    <%= class_name.upcase.swapcase %> = <%= class_name %>.new
    assert <%= class_name.upcase.swapcase %>.valid?, "<%= class_name %> should be valid without initialisation parameters"
    # If <%= class_name %> has validation, then use the following:
    #assert !<%= class_name.upcase.swapcase %>.valid?, "<%= class_name %> should not be valid without initialisation parameters"
    #REQ_ATTR_NAMES.each {|attr_name| assert forum.errors.invalid?(attr_name.to_sym), "Should be an error message for :#{attr_name}"}
  end

	def test_new
    <%= class_name.upcase.swapcase %> = <%= class_name %>.new(NEW_<%= class_name.upcase %>)
    assert <%= class_name.upcase.swapcase %>.valid?, "<%= class_name %> should be valid"
   	NEW_<%= class_name.upcase %>.each do |attr_name|
      assert_equal NEW_FORUM[attr_name], forum.attributes[attr_name], "<%= class_name %>.@#{attr_name.to_s} incorrect"
    end
 	end

	def test_validates_presence_of
   	REQ_ATTR_NAMES.each do |attr_name|
			tmp_<%= class_name.upcase.swapcase %> = NEW_<%= class_name.upcase %>.clone
			tmp_<%= class_name.upcase.swapcase %>.delete attr_name.to_sym
			<%= class_name.upcase.swapcase %> = <%= class_name %>.new(tmp_<%= class_name.upcase.swapcase %>)
			assert !<%= class_name.upcase.swapcase %>.valid?, "<%= class_name %> should be invalid, as @#{attr_name} is invalid"
    	assert forum.errors.invalid?(attr_name.to_sym), "Should be an error message for :#{attr_name}"
    end
 	end

	def test_duplicate
		current_<%= class_name.upcase.swapcase %> = <%= class_name %>.find_first
   	DUPLICATE_ATTR_NAMES.each do |attr_name|
   		<%= class_name.upcase.swapcase %> = <%= class_name %>.new(NEW_<%= class_name.upcase %>.merge(attr_name.to_sym => current_<%= class_name.upcase.swapcase %>[attr_name]))
			assert !<%= class_name.upcase.swapcase %>.valid?, "<%= class_name %> should be invalid, as @#{attr_name} is a duplicate"
    	assert forum.errors.invalid?(attr_name.to_sym), "Should be an error message for :#{attr_name}"
		end
	end
end
